let data_log;
let hPunkte = []; // das Array der Helligkeitspunkte

function preload() {
  // einlesen der Werte in die Variable "data_log"
  // relative Pfade beachten!
  data_log = loadTable("data_log.csv");
}

function setup() {
  const meinCanvas = createCanvas(950, 500);
  meinCanvas.parent("canvasContainer");

  background(240);

  // Roboto als lokaler Webfont eingebunden!
  textFont("roboto");
  textSize(16);

  noStroke();

  // wieviele Zeilen enthält die Datei "data_log.csv"
  let anzahl = data_log.getRowCount();

  // Überschrift
  fill(0);
  text(
    `Alle Tabellenwerte als Graph: Die Tabelle enthält ${anzahl} Datensätze`,
    18,
    30
  );

  // liest alle Helligkeitswerte in das Array ein
  // diese befinden sich in jeder Zeile an der 4. Stelle
  // z.B. "2019-05-27,10:30:01,Helligkeit,144"
  // da hier bei Null angefangen wird zu zählen, hier "3" verwenden
  for (let i = 0; i < anzahl; i++) {
    hPunkte[i] = data_log.getNum(i, 3);
  }

  let b = 35; // Breite des Rechtecks
  let a = b + 4; // Abstand der Rechtecke
  let anfang = 50; // obere Kante der Rechtecke usw.

  // Rechtecke im Hintergrund hilft der Lesbarkeit
  fill(220);
  for (let i = 0; i < anzahl; i++) {
    rect(18 + i * a, anfang, b, 420);
  }

  for (let i = 0; i < anzahl; i++) {
    // zeichnen der Rechtecke, abhängig vom Helligkeitswert
    fill("orange");
    rect(18 + i * a, anfang, b, hPunkte[i]);

    // Nummerierung der Balken
    fill("black");
    textSize(16);
    text(i, 24 + i * a, anfang + 20);

    // Ausgabe des jeweiligen Wertes am unteren Rand des Graphes
    textSize(12);
    text(hPunkte[i], 24 + i * a, anfang + 412);
  }

  // 4 waagrechte Linien alle 100px ("skala") zur Orientierung
  // als letztes gezeichnet, damit oberhalb der Rechteck-Flächen
  stroke(240);
  let skala = 100;
  for (let i = 0; i < 4; i++) {
    line(18, anfang + skala * i, width, anfang + skala * i);
  }
}
